
function getNodes(elem) {
    elems = elem.childNodes;
    res = Array();
    for ( o=0; o<elems.length; o++ ) {
        if ( $type(elems[o]) == 'textnode' || $type(elems[o]) == 'whitespace' ) {
            res.push(elems[o]);
        }
    }
    return res;
}
/*
 * /P[2]/text()#off:64
 */
XPTraverser = function(root, path) {
    this.newoffset = null;

    p = path.split('/');
    p.reverse();
    this.resultnode = this._trav(root, p);
}

XPTraverser.prototype.traverseXPath = function(root, path) {
    p = path.split('/');
    p.reverse();
    return this._trav(root, p);
}

XPTraverser.prototype._trav = function(root, parts) {
    p = parts.pop();
    if ( p ) {
        if ( p.contains('#') ) {
            p = p.split('#');
            offsetraw = p[1];
            p = p[0];
            offset = offsetraw.split(':')[1];
        }
        if ( p.contains('[') ) {
            mat = p.match(/(.*?)\[(.*?)\]/);
            p = mat[1];
            ord = mat[2].toInt();
        } else {
            ord = 1;
        }
        //if ( p != 'text()' ) {
            // TODO: bug here. text() vs. text()[10]
            if ( p != 'text()' ) {
                elems = root.getElements(p);
            } else {
                elems = getNodes(root);
            }
            ord -= 1;
            for ( i=0; i<elems.length; i++ ) {
                if ( $type(elems[i]) != 'textnode' && 
                     $type(elems[i]) != 'whitespace' &&
                     elems[i].hasClass('ignore_xpath') )
                    continue;
                if ( i == ord ) {
                    root = elems[i];
                    break;
                }
            }
        //} else if ( p == 'text()' ) {
        if ( p == 'text()' ) {
            cn = root.childNodes;
            // are we split node?
            text_node_index = 0;
            text_length_count = 0;
            orgoffset = offset.toInt();
            this.newoffset = orgoffset;
            /*
            for ( i=0; i<cn.length; i++ ) {
                if ( cn[i].nodeType == 3) {  // TEXT_NODE
                    var xx = cn[i];
                    text_length_count += cn[i].textContent.length;
                    if ( offset <= text_length_count ) {
                        root = cn[i];
                        this.newoffset = orgoffset;
                        break;
                    } else {
                        orgoffset -= cn[i].textContent.length;
                    }
                } else {
                    if ( !cn[i].hasClass('ignore_xpath') ) {
                        return null;
                    }
                }
            }*/
        }
    }
    if ( parts.length )
        return this._trav(root, parts);
    return root;
}
