# ~*~ coding: utf-8
import xml.dom.minidom
from xml import xpath

from zope.component import getUtility

from views import View as BaseView
from Products.Korpus.interfaces import IDocuments, IKorpus

class MarkDown(BaseView):

    def getSentences(self, eid, infos):
        print "EID:", eid
        k = self.context.korpus_root()
        docs = k.Documents
        res = []
        for i in infos:
            tmp = []
            doc = getattr(docs, i[0])
            if doc.isDeleted():
                print "deleted, skipping!"
                continue
            tmp.append('<a href="'+doc.absolute_url()+'">'+doc.getTitle()+'</a>')
            tmp.append(i[1])
            tmp.append(self._getSentences(doc, i[2]))
            res.append(tmp)
        return res

    def _getSentences(self, doc, xpaths):
        print doc
        res = ""

        start_raw, end_raw = xpaths.split(';')
        start_xp, start_off = start_raw.split('#')
        end_xp, end_off = end_raw.split('#')
        _, start_off = start_off.split(':')
        _, end_off = end_off.split(':')

        start_xp = start_xp.lower()
        end_xp = end_xp.lower()

        if start_xp.startswith('/'): start_xp = start_xp[1:]
        if end_xp.startswith('/'): end_xp = end_xp[1:]

        xmldoc = xml.dom.minidom.parseString(doc.getDocument())
        body = xmldoc.getElementsByTagName('body')[0]

        start_node = xpath.Evaluate(start_xp, body)
        end_node = xpath.Evaluate(end_xp, body)
        # if len(start_node) != 1 or len(end_node) != 1:
        #     print xpaths
        #     print len(start_node), len(end_node)
        #     print start_node, end_node
        #     return "err!"
        #     raise '??'
        start_node = start_node[0]
        end_node = end_node[0]
        f = open('/tmp/current_sentences.txt', 'a+')
        if start_node.isSameNode(end_node):

            txt = start_node.nodeValue
            end_off = int(end_off)
            start_off = int(start_off)

            #res = "&gt;" + start_node.nodeValue[start_off:end_off] + "&lt;"
            res = txt[start_off:end_off]
            pre = []
            p = int(start_off)
            txt = txt
            safety = 0
            while 1:
                if p == 0:
                    break
                p = p - 1
                if txt[p] in ['.', '!', '?']:
                    # got it!
                    break
                else:
                    pre.insert(0, txt[p])
                safety = safety + 1
                if safety > 1000:
                    break
            res = ''.join(pre) + res
            p = int(end_off)
            post = []
            safety = 0
            while 1:
                if p >= len(txt):
                    break
                if txt[p] in ['.', '!', '?']:
                    # got it!
                    post.append(txt[p])
                    break
                else:
                    post.append(txt[p])
                safety = safety + 1
                if safety > 1000:
                    break
                p = p + 1
            res = res + ''.join(post)
        else:
            print xpaths
            print len(start_node), len(end_node)
            # print start_node, end_node
            return "err!"
            raise '!!'
        t = res.replace('\n', ' ')
        f.write(t.encode('utf-8'))
        f.write('\n')
        f.close()
        return res
