# ~*~ coding: utf-8
# täiendid. lubatud ignoreerimiseks.
allowed_ignores_marks = ['@AN>', '@<AN', '@AD>', '@<AD', '@PN>', '@<PN', '@NN>', '@<NN', '@VN>', '@INF_N>', '@<INF_N', '@J', '@Q >', '@<Q', '@P>']

# sõnad lubatud.
allowed_ignores_words = ['ainult', 'arvatavasti', 'eks', 'ent', 'hoopis', 'jah', 'ju', 'juba', 'just', 'ka', 'kas', 'küll', 'küllap', 'las', 'loomulikult', 'minu meelest', 'muidugi', 'no', 'ometi', 'pealegi', 'siis', 'siiski', 'tõenäoliselt', 'vaat', 'veel', 'võib-olla', 'kuigi', 'arvates', 'eelkõige', 'igatahes', 'ilmselt', 'ilmtingimata', 'kahjuks', 'kasvõi', 'kindlasti', 'niisiis', 'samuti', 'seega', 'tõepoolest', 'vist']
# rem puhata


# sõnad ignoreerida, kui esineb ADVL märgend?
conditional_ignore = {'ADVL': ['päris', 'üsna', 'väga', 'hästi', 'täielikult', 'mõneti', 'kõige', 'igati', 'nii', 'peamiselt', 'enam', 'liiga', 'tõsiselt']}


#vajalikud.
needed = ['@OBJ',
'@SUBJ',
'@PRD',
'@+FMV',
'@+FCV',
'@-FMV',
'@ADVL',
'_S_',
'_K_',
'_P_',
'@NEG',
'impf ps3 sg',
'_Z_ Fst',
'_Z_ com',
'indic pres',
'indic impf',
'imper',
'neg',
'ad',
'pres ps1',
'pres ps3 sg',
'impf ps1',
'impf ps3 sg',
'//_D_ //  @ADVL ']


# -- lõpp
# imps
# CLB 
# _Z_ Int 
# 
#  ei tohi olla see.
# sellised _S_ ei sobi. otsida midagi muud.
# -- _S_
# _S_ com sg nom
# _S_ com sg gen
# _S_ com sg part
# _S_ com pl nom
# _S_ com pl gen
# _S_ com pl part
# _S_ prop sg nom
# _S_ prop sg gen
# _S_ prop sg part
# _S_ prop pl nom
# _S_ prop pl gen
# _S_ prop pl part


#-- reeglid
rules = [
['@ADVL', '@+FMV', '@SUBJ', '@ADVL', '@PRD'],
['@ADVL', '@FMV'],
['ad', '@+FCV', '@-FMV', '_S_', '@SUBJ', '//_D_ //  @ADVL'],
['ad', '@+FCV', '@-FMV', '_K_', '@SUBJ', '//_D_ //  @ADVL'],
['ad', '@+FCV', '@-FMV', '_P_', '@SUBJ', '//_D_ //  @ADVL'],
['@SUBJ', '@+FCV', '@-FMV', '_S_', '//_D_ //  @ADVL', '@OBJ'],
['@SUBJ', '@+FCV', '@-FMV', '_K_', '//_D_ //  @ADVL', '@OBJ'],
['@SUBJ', '@+FCV', '@-FMV', '_P_', '//_D_ //  @ADVL', '@OBJ'],
['@SUBJ', '@+FCV', '@-FMV', '@OBJ', '//_D_ //  @ADVL', '@OBJ'],
['@ADVL', '@OBJ', '@+FCV', '//_D_ //  @ADVL', '@-FMV'],
['@ADVL', '@+FMV', '@SUBJ', '@ADVL', '@PRD'],
['@SUBJ', '@+FCV', '@OBJ', '@-FMV', '@-FMV'],
['@PRD', 'CLB', '@SUBJ', '@+FMV', '@ADVL'],
['@J', '@ADVL', '@+FMV', '@OBJ', '//_D_ //  @ADVL'],
['@ADVL', '@+FCV', '@ADVL', '@-FMV', '@SUBJ'],
['@SUBJ', '@+FCV', '_S_', '@OBJ', '@-FMV'],
['@SUBJ', '@+FCV', '_K_', '@OBJ', '@-FMV'],
['@SUBJ', '@+FCV', '_P_', '@OBJ', '@-FMV'],
['@ADVL', '_Z_ com', '@SUBJ', '@+FMV', '@ADVL'],
['@SUBJ', '@NEG', '@+FMV', '_S_', '@OBJ'],
['@SUBJ', '@NEG', '@+FMV', '_K_', '@OBJ'],
['@SUBJ', '@NEG', '@+FMV', '_P_', '@OBJ'],
['@ADVL', '@SUBJ', '@NEG', '@+FMV', '@OBJ'],
['@ADVL', '@NEG', '@+FMV', '_S_', '_X_'],
['@SUBJ', '@+FMV', '_S_', '@OBJ', '@-FMV'],
['@SUBJ', '@+FMV', '_P_', '@OBJ', '@-FMV'],
['@SUBJ', '@+FMV', '_K_', '@OBJ', '@-FMV'],
['@SUBJ', '@+FCV', '@-FMV', '_S_', '@-FMV'],
['@SUBJ', '@+FCV', '@-FMV', '_K_', '@-FMV'],
['@SUBJ', '@+FCV', '@-FMV', '_P_', '@-FMV'],
['@+FCV', '@-FMV', '_S_', '@OBJ', '@-FMV'],
['@+FCV', '@-FMV', '_K_', '@OBJ', '@-FMV'],
['@+FCV', '@-FMV', '_P_', '@OBJ', '@-FMV'],
['ad', '@+FMV', '_S_', '@SUBJ', '//_D_ //  @ADVL'],
['ad', '@+FMV', '_K_', '@SUBJ', '//_D_ //  @ADVL'],
['ad', '@+FMV', '_P_', '@SUBJ', '//_D_ //  @ADVL'],
['ad', '@+FCV', '_S_', '@SUBJ', '//_D_ //  @ADVL'],
['ad', '@+FCV', '_K_', '@SUBJ', '//_D_ //  @ADVL'],
['ad', '@+FCV', '_P_', '@SUBJ', '//_D_ //  @ADVL'],
['ad', 'indic pres', '_S_', '@SUBJ', '//_D_ //  @ADVL'],
['ad', 'indic pres', '_K_', '@SUBJ', '//_D_ //  @ADVL'],
['ad', 'indic pres', '_P_', '@SUBJ', '//_D_ //  @ADVL'],
['ad', 'indic impf', '_S_', '@SUBJ', '//_D_ //  @ADVL'],
['ad', 'indic impf', '_K_', '@SUBJ', '//_D_ //  @ADVL'],
['ad', 'indic impf', '_P_', '@SUBJ', '//_D_ //  @ADVL'],
['@SUBJ', '@+FCV', '_S_', '//_D_ //  @ADVL', '@-FMV'],
['@SUBJ', '@+FCV', '_K_', '//_D_ //  @ADVL', '@-FMV'],
['@SUBJ', '@+FCV', '_P_', '//_D_ //  @ADVL', '@-FMV'],
['@SUBJ', '@+FCV', '@OBJ', '//_D_ //  @ADVL', '@-FMV'],
['@SUBJ', '@+FMV', '_S_', '//_D_ //  @ADVL', '@OBJ'],
['@SUBJ', '@+FMV', '_K_', '//_D_ //  @ADVL', '@OBJ'],
['@SUBJ', '@+FMV', '_P_', '//_D_ //  @ADVL', '@OBJ'],
['@SUBJ', '@+FMV', '@OBJ', '//_D_ //  @ADVL', '@OBJ'],
['ps1', '@-FMV', '_S_', '//_D_ //  @ADVL', '@OBJ'],
['ps1', '@-FMV', '_K_', '//_D_ //  @ADVL', '@OBJ'],
['ps1', '@-FMV', '_P_', '//_D_ //  @ADVL', '@OBJ'],
['ps1', '@-FMV', '@OBJ', '//_D_ //  @ADVL', '@OBJ'],
['ps3 sg', '@-FMV', '_S_', '//_D_ //  @ADVL', '@OBJ'],
['ps3 sg', '@-FMV', '_K_', '//_D_ //  @ADVL', '@OBJ'],
['ps3 sg', '@-FMV', '_P_', '//_D_ //  @ADVL', '@OBJ'],
['ps3 sg', '@-FMV', '@OBJ', '//_D_ //  @ADVL', '@OBJ'],
['@SUBJ', '@+FCV', '@-FMV', '_X_', '@OBJ'],
['@ADVL', '@+FCV', '@SUBJ', '@OBJ', '@-FMV'],
['_S_', '@+FMV', '@SUBJ', '@-FMV', '@OBJ'],
['_K_', '@+FMV', '@SUBJ', '@-FMV', '@OBJ'],
['_P_', '@+FMV', '@SUBJ', '@-FMV', '@OBJ'],
['@ADVL', '@+FMV', '@SUBJ', '@OBJ', '@-FMV'],
['@ADVL', '@+FMV', '_S_', '@OBJ'],
['@ADVL', '@+FMV', '_K_', '@OBJ'],
['@ADVL', '@+FMV', '_P_', '@OBJ'],
['@SUBJ', '@+FCV', '_S_', '@-FMV'],
['@SUBJ', '@+FCV', '_K_', '@-FMV'],
['@SUBJ', '@+FCV', '_P_', '@-FMV'],
['@SUBJ', '@+FCV', '@OBJ', '@-FMV'],
['@ADVL', '@+FCV', '@SUBJ', '@ADVL'],
['@PRD', '@+FMV', '@ADVL', '@SUBJ'],
['@SUBJ', '@+FMV', '@OBJ', '_S_'],
['@SUBJ', '@+FMV', '@OBJ', '_K_'],
['@SUBJ', '@+FMV', '@OBJ', '_P_'],
['@ADVL', '@+FCV', '@SUBJ', '@OBJ'],
['@ADVL', '@SUBJ', '@+FMV', '@ADVL'],
['@+FCV', '_S_', '//_D_ //  @ADVL', '@-FMV'],
['@+FCV', '_K_', '//_D_ //  @ADVL', '@-FMV'],
['@+FCV', '_P_', '//_D_ //  @ADVL', '@-FMV'],
['@ADVL', '@+FMV', '@SUBJ', '@ADVL'],
['CLB', '@+FMV', '@ADVL', '@SUBJ'],
['@ADVL', '@+FMV', '//_D_ //  @ADVL', '@SUBJ'],
['@SUBJ', '@+FMV', '_K_', '@OBJ'],
['@J', '@+FMV', '@SUBJ', '@PRD'],
['@SUBJ', '@+FMV', '_K_', '_S_'],
['@SUBJ', '@+FMV', '_K_', '_K_'],
['@SUBJ', '@+FMV', '_K_', '_P_'],
['@SUBJ', '@ADVL', '@+FMV', '@OBJ'],
['@SUBJ', '@OBJ', '@NEG', '@+FMV'],
['@J', '@SUBJ', '@NEG', '@+FMV'],
['@SUBJ', '@NEG', '@+FMV', '_S_'],
['@SUBJ', '@NEG', '@+FMV', '_K_'],
['@SUBJ', '@NEG', '@+FMV', '_P_'],
['@ADVL', '@NEG', '@+FMV', '_K_'],
['@ADVL', '@NEG', '@+FMV', '_P_'],
['@SUBJ', '@+FCV', '@ADVL', '@-FMV'],
['@SUBJ', '@+FCV', '@-FMV', '@ADVL'],
['@SUBJ', '@NEG', '@+FMV', '@OBJ'],
['@SUBJ', '@+FCV', '@-FMV', '_S_'],
['@SUBJ', '@+FCV', '@-FMV', '_K_'],
['@SUBJ', '@+FCV', '@-FMV', '_P_'],
['@SUBJ', '@NEG', '@+FCV', '@-FMV'],
['@SUBJ', '@NEG', '@+FCV', '@OBJ'],
['@ADVL', '@+FMV', '@SUBJ', '@PRD'],
['@ADVL', '@+FMV', '@ADVL', '@SUBJ'],
['@SUBJ', 'indic pres', '_S_', '@OBJ'],
['@SUBJ', 'indic pres', '_K_', '@OBJ'],
['@SUBJ', 'indic pres', '_P_', '@OBJ'],
['@SUBJ', 'indic impf', '_S_', '@OBJ'],
['@SUBJ', 'indic impf', '_K_', '@OBJ'],
['@SUBJ', 'indic impf', '_P_', '@OBJ'],
['@SUBJ', '@+FMV', '_P_', '@OBJ'],
['@+FCV', '_S_', '@OBJ', '@-FMV'],
['@+FCV', '_K_', '@OBJ', '@-FMV'],
['@+FCV', '_P_', '@OBJ', '@-FMV'],
['ps1', '_K_', '@OBJ', '@-FMV'],
['ps1', '_P_', '@OBJ', '@-FMV'],
['ps3 sg', '_K_', '@OBJ', '@-FMV'],
['ps3 sg', '_P_', '@OBJ', '@-FMV'],
['imper', '_S_', '@OBJ', '@-FMV'],
['imper', '_P_', '@OBJ', '@-FMV'],
['@SUBJ', '@+FCV', '@OBJ', '@-FMV'],
['neg', '@+FMV', '_S_', '//_D_ //  @ADVL'],
['neg', '@+FMV', '_K_', '//_D_ //  @ADVL'],
['neg', '@+FMV', '_P_', '//_D_ //  @ADVL'],
['@SUBJ', '@+FMV', '_S_', '//_D_ //  @ADVL'],
['@SUBJ', '@+FMV', '_K_', '//_D_ //  @ADVL'],
['@SUBJ', '@+FMV', '_P_', '//_D_ //  @ADVL'],
['@SUBJ', '@+FMV', '@OBJ', '//_D_ //  @ADVL'],
['@SUBJ', '@+FCV', '_S_', '//_D_ //  @ADVL'],
['@SUBJ', '@+FCV', '_K_', '//_D_ //  @ADVL'],
['@SUBJ', '@+FCV', '_P_', '//_D_ //  @ADVL'],
['@SUBJ', '@+FCV', '@OBJ', '//_D_ //  @ADVL'],
['imper', '_S_', '//_D_ //  @ADVL', '@OBJ'],
['imper', '_K_', '//_D_ //  @ADVL', '@OBJ'],
['imper', '_P_', '//_D_ //  @ADVL', '@OBJ'],
['imper', '@OBJ', '//_D_ //  @ADVL', '@OBJ'],
['@+FCV', '@OBJ', '//_D_ //  @ADVL', '@-FMV'],
['pres ps1', '_S_', '//_D_ //  @ADVL', '@OBJ'],
['pres ps1', '_K_', '//_D_ //  @ADVL', '@OBJ'],
['pres ps1', '_P_', '//_D_ //  @ADVL', '@OBJ'],
['pres ps1', '@OBJ', '//_D_ //  @ADVL', '@OBJ'],
['pres ps3 sg', '_S_', '//_D_ //  @ADVL', '@OBJ'],
['pres ps3 sg', '_K_', '//_D_ //  @ADVL', '@OBJ'],
['pres ps3 sg', '_P_', '//_D_ //  @ADVL', '@OBJ'],
['pres ps3 sg', '@OBJ', '//_D_ //  @ADVL', '@OBJ'],
['impf ps1', '_S_', '//_D_ //  @ADVL', '@OBJ'],
['impf ps1', '_K_', '//_D_ //  @ADVL', '@OBJ'],
['impf ps1', '_P_', '//_D_ //  @ADVL', '@OBJ'],
['impf ps1', '@OBJ', '//_D_ //  @ADVL', '@OBJ'],
['impf ps3 sg', '_S_', '//_D_ //  @ADVL', '@OBJ'],
['impf ps3 sg', '_K_', '//_D_ //  @ADVL', '@OBJ'],
['impf ps3 sg', '_P_', '//_D_ //  @ADVL', '@OBJ'],
['impf ps3 sg', '@OBJ', '//_D_ //  @ADVL', '@OBJ'],
['@+FMV', '_S_', '//_D_ //  @ADVL', '@OBJ'],
['@+FMV', '_K_', '//_D_ //  @ADVL', '@OBJ'],
['@+FMV', '_P_', '//_D_ //  @ADVL', '@OBJ'],
['@+FMV', '@OBJ', '//_D_ //  @ADVL', '@OBJ'],
['@SUBJ', '@+FCV', '_X_', '@-FMV'],
['@SUBJ', '@+FMV', '_X_', '@OBJ'],
['@ADVL', '@+FCV', '@SUBJ', '@-FMV'],
['@SUBJ', '@+FMV', '@OBJ', '@ADVL'],
['@ADVL', '@+FMV', '@SUBJ', '@-FMV'],
['@SUBJ', '@NEG', '@+FMV', '@-FMV'],
['@ADVL', '@+FMV', '@SUBJ', '@OBJ'],
['@SUBJ', '@+FMV', '@PRD'],
['@SUBJ', '@+FMV', '_S_'],
['@SUBJ', '@+FMV', '_K_'],
['@SUBJ', '@+FMV', '_P_'],
['@ADVL', '@+FMV', '@SUBJ'],
['@ADVL', '@+FMV', '@OBJ'],
['@SUBJ', '@+FCV', '@PRD'],
['@SUBJ', '@+FMV', '@ADVL'],
['@SUBJ', '@+FMV', '_Z_ Fst'],
['@SUBJ', '@+FCV', '@-FMV'],
['@OBJ', '@+FMV', '@ADVL'],
['@+FMV', '@PRD', '_Z_ Fst'],
['@ADVL', '@+FCV', '@SUBJ'],
['@SUBJ', '@+FMV', '@-FMV'],
['@+FMV', '@ADVL', '@PRD'],
['@SUBJ', '@+FMV', '@OBJ'],
['@SUBJ', '@+FMV', '@-FMV'],
['@+FCV', '@OBJ', '@-FMV'],
['@+FMV', '@ADVL', '_Z_ Fst'],
['@SUBJ', '@NEG', '@+FMV'],
['@+FMV', '@OBJ', '_Z_ Fst'],
['ps3 sg', '//_D_ //  @ADVL', '_Z_ Fst'],
['ps1', '@OBJ', '_Z_ Fst'],
['ps3 sg', '@ADVL', '_Z_ Fst'],
['ps3 sg', '@-FMV', '_Z_ Fst'],
['ps3 sg', '@PRD', '_Z_ Fst'],
['@SUBJ', '@+FMV', '@-FMV'],
['@+FMV', '@SUBJ', '_Z_ Fst'],
['@ADVL', '@+FMV', '@ADVL'],
['imper', '_S_', '@OBJ'],
['imper', '_K_', '@OBJ'],
['imper', '_P_', '@OBJ'],
['ps1', '_S_', '@OBJ'],
['ps1', '_K_', '@OBJ'],
['ps1', '_P_', '@OBJ'],
['ps3 sg', '_S_', '@OBJ'],
['ps3 sg', '_K_', '@OBJ'],
['ps3 sg', '_P_', '@OBJ'],
['@+FMV', '_S_', '@OBJ'],
['@+FMV', '_K_', '@OBJ'],
['@+FMV', '_P_', '@OBJ'],
['imper', '@OBJ', '_Z_ Fst'],
['@SUBJ', '@+FCV', '_S_'],
['@SUBJ', '@+FCV', '_K_'],
['imper', '_S_', '_Z_ Fst'],
['imper', '_K_', '_Z_ Fst'],
['imper', '_P_', '_Z_ Fst'],
['imper', '_S_', '//_D_ //  @ADVL'],
['imper', '_K_', '//_D_ //  @ADVL'],
['imper', '_P_', '//_D_ //  @ADVL'],
['imper', '@OBJ', '//_D_ //  @ADVL'],
['pres ps1', '_S_', '//_D_ //  @ADVL'],
['pres ps1', '_K_', '//_D_ //  @ADVL'],
['pres ps1', '_P_', '//_D_ //  @ADVL'],
['pres ps1', '@OBJ', '//_D_ //  @ADVL'],
['pres ps3 sg', '_S_', '//_D_ //  @ADVL'],
['pres ps3 sg', '_K_', '//_D_ //  @ADVL'],
['pres ps3 sg', '_P_', '//_D_ //  @ADVL'],
['pres ps3 sg', '@OBJ', '//_D_ //  @ADVL'],
['impf ps1', '_S_', '//_D_ //  @ADVL'],
['impf ps1', '_K_', '//_D_ //  @ADVL'],
['impf ps1', '_P_', '//_D_ //  @ADVL'],
['impf ps1', '@OBJ', '//_D_ //  @ADVL'],
['impf ps3 sg', '_S_', '//_D_ //  @ADVL'],
['impf ps3 sg', '_K_', '//_D_ //  @ADVL'],
['impf ps3 sg', '_P_', '//_D_ //  @ADVL'],
['impf ps3 sg', '@OBJ', '//_D_ //  @ADVL'],
['@SUBJ', '@+FMV', '_X_'],
['@SUBJ', '@+FCV', '_X_'],
['@+FCV', '_X_', '@-FMV'],
['@+FMV', '_X_', '@OBJ'],
['//_D_ //  @ADVL', '@+FMV', '@SUBJ'],
['impf ps3 sg', '_P_', '//_D_ //  @ADVL'],
['@+FMV', '_Z_ Fst'],
['imper', '_X_']
]

