import subprocess
from twisted.enterprise import adbapi
from twisted.internet import reactor

#MORFO_PROGS="/home/vahur/estmorf/TLU"
MORFO_PROGS="/home/jaagup/estmorf"
cmd = "./estmorf.sh | ./kms2cg3.pl | vislcg3 --grammar trivial.rle | vislcg3 --grammar morfyhest170609.rlb  | vislcg3 --grammar pindsyn170609.rlb | vislcg3 --grammar strukt170609.rlb"
dbpool = adbapi.ConnectionPool('psycopg2', user='evkk', database='evkktest')
#dbpool = adbapi.ConnectionPool('psycopg2', user='evkk', database='evkktest2')

def getText(txn):
    res = txn.execute("select documentid, plaintext from texts where status=1 and skip='f' and documentid not in ( select documentid from analysis) and documentid in (select documentid from documents where language='et') limit 1")
    res = txn.fetchall()
    if len(res) > 0:
        return [res[0][0], res[0][1]]
    else:
        print "... all done for now!"
        reactor.callLater(5, reactor.stop)
    return None

def processText(res):
    if res is not None:
        did = res[0]
        t = res[1]
        if len(t) > 6000:
            print "skipping...", did
            dbpool.runOperation("UPDATE texts SET skip='t' WHERE documentid='%s'" % did)
        else:
            a = subprocess.Popen("./estmorf.sh | ./kms2cg3.pl | vislcg3 --grammar trivial.rle | vislcg3 --grammar morfyhest170609.rlb  | vislcg3 --grammar pindsyn170609.rlb | vislcg3 --grammar strukt170609.rlb", cwd=MORFO_PROGS, shell=True, stderr=subprocess.PIPE, stdin=subprocess.PIPE, stdout=subprocess.PIPE)
            stdo, stde = a.communicate(t)
            dbpool.runOperation("INSERT INTO analysis VALUES ('%s', '%s')" % (did, stdo))
            print "lisati ", did, stdo, stde
    reactor.callLater(10, start)

def start():
    x = dbpool.runInteraction(getText)
    x.addCallback(processText)

start()
reactor.run()
