#!/usr/bin/python2.4
import sys
import subprocess
from twisted.enterprise import adbapi
from twisted.internet import reactor

MORFO_PROGS="/home/vahur/estmorf/TLU"
cmd = "./estmorf.sh | ./kms2cg3.pl | vislcg3 -C UTF-8 --grammar trivial.rle | vislcg3 -C UTF-8 --grammar morfyhest170609.rlb  | vislcg3 -C UTF-8 --grammar pindsyn170609.rlb | vislcg3 -C UTF-8 --grammar strukt170609.rlb"
dbpool = adbapi.ConnectionPool('psycopg2', user='evkk', database='evkktest')

docid = sys.argv[1]

def getText(txn):
    txn.execute("select documentid, plaintext from texts where documentid=%s", [docid])
    res = txn.fetchall()
    if len(res) > 0:
        return res[0]
    else:
        print "... nothing for me!"
    return None

def processText(res):
    docid, txt = res
    #i = 0
    for s in txt.split('\n'):
        #continue
        a = subprocess.Popen(cmd, cwd=MORFO_PROGS, shell=True, stderr=subprocess.PIPE, stdin=subprocess.PIPE, stdout=subprocess.PIPE)
        stdo, stde = a.communicate(s)
        dbpool.runOperation("INSERT INTO sentences (documentid, sentence, analysis) VALUES (%s, %s, %s)", (docid, s, stdo))
    reactor.callLater(1, reactor.stop)

def start():
    x = dbpool.runInteraction(getText)
    x.addCallback(processText)

start()
reactor.run()
