import objects
dyn_rules = objects.RulesList([
	{0: ['@SUBJ', '@FMV']} ,
	{1: ['@ADVL', '@ADVL', '@FMV', '@SUBJ']} ,
	{2: ['@ADVL', '@SUBJ', '@FMV']} ,
	{3: ['@ADVL', '@SUBJ', '@FMV', '@OBJ']} ,
	{4: ['@SUBJ', '@ADVL', '@FMV']} ,
	{5: ['@ADVL', '@FMV', '@SUBJ']} ,
	{6: ['@ADVL', '@SUBJ', '@FMV', '@PRD']} ,
	{7: ['@FMV', '@ADVL']} ,
	{8: ['@FMV', '@OBJ']} ,
	{9: ['@FMV', '@SUBJ']} ,
	{10: ['@SUBJ', '@ADVL', '@FMV', '@ADVL']} ,
	{11: ['@FMV', '@IMV']} ,
	{12: ['@ADVL', '@SUBJ', '@FMV', '@OBJ', '@ADVL']} ,
	{13: ['@ADVL', '@ADVL', '@SUBJ', '@FMV', '@ADVL']} ,
	{14: ['@ADVL', '@ADVL', '@SUBJ', '@FMV', '@OBJ']} ,
	{15: ['@OBJ', '@FMV']} ,
	{16: ['@ADVL', '@FMV']} ,
	{17: ['@FMV', '@ADVL', '@ADVL']} ,
	{18: ['@FMV', '@PRD']} ,
	{19: [' P ', '@ADVL', '@SUBJ', '@FMV', '@ADVL']} ,
	{20: ['@ADVL', '@ADVL', '@FMV', '@ADVL']} ,
	{21: ['@ADVL', '@ADVL', '@SUBJ', '@FMV']} ,
	{22: ['@ADVL', ' P ']} ,
	{23: ['@ADVL', '@FMV', '@SUBJ', '@ADVL']} ,
	{24: ['@SUBJ', '@ADVL', '@NEG', '@FMV']} ,
	{25: ['@ADVL', '@SUBJ', '@FMV', '@SUBJ']} ,
	{26: ['ad', '@ADVL', '@SUBJ', '@FMV', '@ADVL']} ,
	{27: ['@OBJ', '@FMV', '@SUBJ']} ,
	{28: ['@ADVL', '@ADVL', '@ADVL', '@FMV', '@ADVL']} ,
	{29: ['@ADVL', 'Z Com', '@SUBJ', '@FMV', '@PRD']} ,
	{30: ['@ADVL', '@ADVL', '@FMV']} ,
	{31: ['@ADVL', '@ADVL', '@FMV', '@ADVL', '@SUBJ']} ,
	{32: ['@PRD', '@FMV', '@SUBJ']} ,
	{33: [' P ', '@ADVL', '@SUBJ', '@FMV', '@PRD']} ,
	{34: ['@ADVL', '@SUBJ', '@ADVL', '@FMV', '@ADVL']} ,
	{35: ['@OBJ', '@SUBJ', '@FMV']} ,
	{36: ['@OBJ', '@SUBJ', '@FMV', '@ADVL']} ,
	{37: ['@SUBJ', '@ADVL']} ,
	{38: ['@FMV', '@SUBJ', '@ADVL']} ,
	{39: [' P ', '@ADVL', '@SUBJ', '@FMV', '@OBJ']} ,
	{40: ['@ADVL', '@SUBJ', '@OBJ', '@FMV', '@ADVL']} ,
	{41: ['@OBJ', '@FMV', '@OBJ']} ,
	{42: ['@ADVL', '@ADVL', '@ADVL', '@FMV', '@SUBJ']} ,
	{43: ['@ADVL', '@ADVL', '@SUBJ']} ,
	{44: ['@FMV', '@OBJ', '@ADVL']} ,
	{45: ['@ADVL', '@ADVL', '@FMV', '@SUBJ', '@ADVL']} ,
	{46: ['@ADVL', '@SUBJ', '@ADVL', '@FMV']} ,
	{47: ['@ADVL', '@ADVL', '@FMV', '@SUBJ', '@PRD']} ,
	{48: ['@SUBJ', '@OBJ', '@FMV']} ,
	{49: ['@SUBJ', '@FMV', '@ADVL']} ,
	{50: ['@SUBJ', '@ADVL', '@ADVL', '@FMV']} ,
	{51: ['@ADVL', '@NEG', '@FMV']} ,
	{52: ['@ADVL', '@SUBJ', '@FMV', 'ad', '@ADVL']} ,
	{53: ['@ADVL', '@ADVL', '@SUBJ', '@FMV', '@PRD']} ,
	{54: ['@OBJ', '@IMV']} ,
	{55: ['@ADVL', '@FMV', '@PRD', '@ADVL', '@SUBJ', '@FMV', '@ADVL', '@ADVL']} ,
	{56: ['@ADVL', '@ADVL', '@NEG', '@FMV', '@SUBJ']} ,
	{57: ['@ADVL', '@SUBJ', '@FMV', '@IMV']} ,
	{58: ['@ADVL', '@PRD', '@FMV', '@SUBJ']} ,
	{59: ['@ADVL', '@FMV', '@PRD']} ,
	{60: ['@ADVL', '@SUBJ', '@FMV', '@OBJ', '@ADVL', '@OBJ']} ,
	{61: ['@SUBJ', '@FMV', 'Z Com', ' P ', '@ADVL', '@ADVL', '@ADVL', '@FMV', '@SUBJ']} ,
	{62: ['@SUBJ', '@ADVL', '@FMV', '@PRD']} ,
	{63: ['@ADVL', '@ADVL', '@FMV', '@ADVL', '@ADVL', '@SUBJ']} ,
	{64: ['@SUBJ', '@ADVL', ' P ', '@ADVL', '@FMV', '@OBJ', '@ADVL']} ,
	{65: ['@ADVL', '@ADVL', '@OBJ', '@FMV']} ,
	{66: ['@OBJ', '@ADVL', '@SUBJ', '@FMV']} ,
	{67: ['@PRD', '@FMV', '@SUBJ', '@OBJ']} ,
	{68: ['@OBJ', '@ADVL']} ,
	{69: ['@ADVL', '@SUBJ', '@FMV', '@IMV', '@OBJ']} ,
	{70: ['@ADVL', '@ADVL', '@FMV', '@OBJ', '@ADVL']} ,
	{71: ['@ADVL', '@SUBJ', '@FMV', '@IMV', '@OBJ', '@ADVL']} ,
	{72: ['@FMV', '@ADVL', '@SUBJ']} ,
	{73: ['@ADVL', '@SUBJ', '@FCV', '@ADVL', '@IMV']} ,
	{74: ['@SUBJ', '@FMV', '@FMV', '@PRD']} ,
	{75: ['@ADVL', '@ADVL', '@FMV', '@OBJ']} ,
	{76: ['@SUBJ', '@ADVL', '@FMV', '@SUBJ']} ,
	{77: ['@ADVL', '@FMV', '@IMV']} ,
	{78: ['@ADVL', '@ADVL', '@OBJ', '@ADVL', '@FMV', '@ADVL', '@ADVL', '@ADVL']} ,
	{79: ['@ADVL', 'Z Com', '@ADVL', '@FMV', '@SUBJ']} ,
	{80: ['@ADVL', '@ADVL', '@ADVL', '@FMV', '@OBJ', '@ADVL', '@ADVL', '@ADVL', ' S ', '@OBJ']} ,
	{81: ['@ADVL', '@OBJ', '@FMV', '@SUBJ']} ,
	{82: ['@ADVL', '@ADVL', '@ADVL', '@NEG', '@FMV', '@SUBJ']} ,
	{83: ['@OBJ', '@FMV', '@SUBJ', '@ADVL']} ,
	{84: [' P ', '@ADVL', '@SUBJ', '@FMV']} ,
	{85: ['@NEG', '@FMV', '@SUBJ']} ,
	{86: ['@FMV', '@SUBJ', '@ADVL', '@ADVL', '@FMV', '@FMV', '@ADVL', '@ADVL', '@IMV', '@OBJ', '@IMV']} ,
	{87: ['@ADVL', '@SUBJ', '@ADVL', '@FMV', '@PRD']} ,
	{88: ['@ADVL', 'Z Com', '@SUBJ', '@FMV']} ,
	{89: ['@ADVL', '@SUBJ', '@FCV', '@IMV', '@ADVL']} ,
	{90: ['@ADVL', ' S ', '@SUBJ', '@FMV', '@OBJ']} ,
	{91: ['@FMV', '@SUBJ', '@ADVL', 'Z Com', '@ADVL', '@ADVL', '@ADVL']} ,
	{92: ['@ADVL', '@OBJ', '@SUBJ', '@FMV', '@OBJ', '@ADVL']} ,
	{93: ['Z Com', '@ADVL', '@FMV', '@SUBJ', '@ADVL', '@ADVL', '@IMV']} ,
	{94: ['@ADVL', '@ADVL', '@FMV', '@OBJ', '@SUBJ']} ,
	{95: ['@SUBJ', '@ADVL', '@ADVL', '@FMV', '@OBJ', '@ADVL']} ,
	{96: ['@FMV', '@PRD', '@SUBJ']} ,
	{97: [' P ', '@ADVL', '@ADVL', '@FMV', '@SUBJ']} ,
	{98: ['@ADVL', ' S ', '@ADVL', '@ADVL', '@ADVL', '@SUBJ', '@FMV', '@ADVL']} ,
	{99: ['@FMV', '@PRD', '@ADVL']} ,
	{100: ['@ADVL', '@ADVL', '@PRD', '@ADVL', '@FMV', '@SUBJ']} ,
	{101: ['@ADVL', '@SUBJ', '@FMV', '@OBJ', '@ADVL', '@ADVL']} ,
	{102: ['@ADVL', '@SUBJ', '@ADVL', '@OBJ', '@NEG', '@FMV']} ,
	{103: ['@SUBJ', '@ADVL', '@OBJ', '@ADVL', '@FMV']} ,
	{104: ['@OBJ', '@ADVL', '@FMV', '@SUBJ']} ,
	{105: ['@OBJ', '@FMV', '@IMV', '@OBJ', '@ADVL']} ,
	{106: ['@SUBJ', '@OBJ', '@FMV', '@OBJ']} ,
	{107: [' P ', '@ADVL', '@PRD', '@FMV', '@SUBJ']} ,
	{108: ['@FMV', '@OBJ', '@ADVL', '@OBJ']} ,
	{109: ['@ADVL', '@ADVL', 'Z Com', '@ADVL', '@OBJ', '@ADVL', '@FMV']} ,
	{110: ['@ADVL', ' S ', '@ADVL', '@FMV', '@ADVL', '@ADVL']} ,
	{111: ['@OBJ', 'Z Com', '@ADVL', '@ADVL', '@ADVL', '@FMV', '@SUBJ']} ,
	{112: ['@ADVL', '@SUBJ', '@IMV']} ,
	{113: ['@SUBJ', '@ADVL', ' S ', '@OBJ', '@FMV', '@IMV', '@OBJ', '@FMV', '@ADVL', '@OBJ']} ,
	{114: ['ad', '@ADVL', '@ADVL', '@FMV', '@SUBJ']} ,
	{115: ['@FMV', '@FMV', '@ADVL', '@SUBJ']} ,
	{116: ['@SUBJ', '@OBJ', '@IMV', '@ADVL', 'Z Com', '@ADVL', '@ADVL']} ,
	{117: ['@ADVL', '@OBJ', '@SUBJ', '@FMV', '@IMV', '@FMV', '@ADVL']} ,
	{118: ['@OBJ', '@ADVL', '@FMV']} ,
	{119: ['@ADVL', '@OBJ']} ,
	{120: ['@ADVL', '@SUBJ', '@ADVL', '@NEG', '@FMV']} ,
	{121: ['@SUBJ', '@ADVL', 'Z Com', '@ADVL', '@FMV', '@ADVL', '@ADVL']} ,
	{122: ['@ADVL', '@NEG', '@FMV', '@SUBJ']} ,
	{123: ['@ADVL', '@ADVL', ' S ', '@FMV', '@ADVL', '@SUBJ']} ,
	{124: ['@ADVL', '@ADVL', ' S ']} ,
	{125: ['@ADVL', '@IMV', '@OBJ']} ,
	{126: ['@FMV', '@SUBJ', '@OBJ', '@ADVL', '@ADVL', '@OBJ', '@ADVL', '@IMV', 'Z Com', '@ADVL', '@OBJ']} ,
	{127: ['Z Com', '@ADVL', '@FMV', '@ADVL', '@PRD']} ,
	{128: ['@ADVL', '@ADVL', '@OBJ', '@NEG', '@FMV']} ,
	{129: ['@ADVL', '@SUBJ', '@ADVL', '@FMV', '@PRD', '@ADVL']} ,
	{130: ['@FMV', '@ADVL', '@OBJ', '@IMV']} ,
	{131: ['Z Com', '@ADVL', '@FMV', '@SUBJ']} ,
	{132: ['@ADVL', '@ADVL', '@OBJ']} ,
	{133: ['ad', '@ADVL', '@FMV', '@ADVL', '@IMV', '@OBJ', '@SUBJ', '@FMV', '@IMV']} ,
	{134: ['@FMV', '@IMV', '@OBJ', '@ADVL']} ,
	{135: ['@OBJ', '@SUBJ', '@IMV', '@FMV']} ,
	{136: ['@SUBJ', '@ADVL', '@FMV', '@ADVL', '@ADVL']} ,
	{137: ['@ADVL', '@SUBJ', '@FMV', ' P ', '@ADVL', '@ADVL']} ,
	{138: ['ad', '@ADVL', '@SUBJ', '@FMV', '@ADVL', '@OBJ']} ,
	{139: ['@FMV', '@IMV', '@ADVL', '@SUBJ']} ,
	{140: ['@ADVL', '@ADVL', '@FMV', '@PRD', '@SUBJ']} ,
	{141: ['@SUBJ', '@FMV', '@PRD']} ,
	{142: ['@ADVL', '@ADVL', '@NEG', '@FMV']} ,
	{143: ['Z Com', '@OBJ', '@ADVL', '@FMV', '@IMV', '@PRD']} ,
	{144: ['@OBJ', '@NEG', '@FMV', '@SUBJ']} ,
	{145: ['@ADVL', '@ADVL', '@FMV', '@ADVL', '@OBJ']} ,
	{146: ['@ADVL', '@ADVL', '@SUBJ', '@FMV', '@ADVL', '@ADVL']} ,
	{147: ['Z Com', '@ADVL', '@FMV', '@ADVL', '@SUBJ']} ,
	{148: ['@OBJ', '@FMV', '@SUBJ', '@OBJ']} ,
	{149: ['@PRD', ' P ', '@ADVL', '@ADVL', '@FMV']} ,
	{150: ['@ADVL', '@OBJ', '@NEG', '@FMV']} ,
	{151: ['@SUBJ', '@ADVL', '@ADVL', '@ADVL', '@FMV']} ,
	{152: ['@IMV', '@OBJ']} ,
	{153: ['@ADVL', '@ADVL', '@ADVL', '@ADVL', '@ADVL', '@FMV', '@PRD', '@OBJ', '@SUBJ']} ,
	{154: ['@ADVL', '@SUBJ', '@FCV', '@IMV', '@ADVL', '@OBJ']} ,
	{155: ['@ADVL', '@ADVL', '@NEG', '@FMV', '@SUBJ', '@ADVL']} ,
	{156: ['@SUBJ', 'Z Com', '@ADVL', 'Z Com', '@ADVL', '@NEG', '@FMV']} ,
	{157: ['Z Com', '@ADVL', '@NEG', '@FMV', '@SUBJ']} ,
	{158: ['@SUBJ', '@ADVL', '@ADVL', '@ADVL', '@FMV', '@ADVL']} ,
	{159: [' P ', '@ADVL', 'Z Com', '@SUBJ', '@FMV', '@ADVL']} ,
	{160: ['@ADVL', '@SUBJ', '@FCV', '@IMV']} ,
	{161: ['@PRD', '@FMV', 'Z Com', '@SUBJ']} ,
	{162: ['@SUBJ', '@FMV', '@FMV', '@OBJ', '@PRD']} ,
	{163: ['@ADVL', '@ADVL', '@FMV', '@PRD']} ,
	{164: ['@ADVL', 'Z Com', '@ADVL', '@SUBJ', '@FMV', '@ADVL']} ,
	{165: ['@SUBJ', ' P ', '@ADVL', '@FMV', '@ADVL']} ,
	{166: ['@ADVL', ' P ', '@ADVL', '@SUBJ', '@FMV', '@IMV']} ,
	{167: ['@ADVL', '@NEG', '@FMV', '@ADVL']} ,
	{168: ['@ADVL', '@ADVL', '@ADVL', '@OBJ', '@FMV', '@IMV']} ,
	{169: ['@ADVL', '@OBJ', '@SUBJ', '@ADVL', '@FMV', '@IMV', '@ADVL']} ,
	{170: ['@ADVL', '@SUBJ', '@NEG', '@FMV', '@OBJ', '@ADVL', '@ADVL']} ,
	{171: ['@FMV', '@ADVL', '@ADVL', '@ADVL']} ,
	{172: ['Z Com', '@ADVL', '@FMV', '@SUBJ', '@OBJ', '@ADVL']} ,
	{173: ['@ADVL', '@FCV', '@IMV', '@SUBJ', '@ADVL', 'Z Fst', '@ADVL', '@OBJ']} ,
	{174: ['@SUBJ', '@PRD']} ,
	{175: ['Z Com', '@SUBJ', '@FMV']} ,
	{176: ['@ADVL', '@FMV', '@PRD', '@ADVL', '@ADVL']} ,
	{177: ['@ADVL', '@SUBJ', '@FMV', '@IMV', '@ADVL']} ,
	{178: ['@SUBJ', '@ADVL', '@NEG', '@FMV', '@OBJ', '@ADVL', '@IMV', '@OBJ', '@IMV']} ,
	{179: ['@ADVL', '@ADVL', '@NEG', '@FMV', '@OBJ', '@ADVL', '@ADVL']} ,
	{180: ['@SUBJ', '@FMV', 'Z Com', ' S ', ' P ', '@ADVL', '@SUBJ', '@FMV', '@OBJ']} ,
	{181: ['@ADVL', '@SUBJ', '@ADVL', '@FMV', '@OBJ']} ,
	{182: ['@ADVL', '@FMV', '@PRD', '@ADVL', '@NEG', '@FMV', '@ADVL']} ,
	{183: ['@FMV', '@IMV', '@SUBJ', '@FMV', '@PRD']} ,
	{184: ['@FCV', '@IMV', '@ADVL', '@ADVL']} ,
	{185: ['@SUBJ', '@ADVL', '@FMV', '@FMV', '@ADVL', '@PRD']} ,
	{186: ['@OBJ', '@ADVL', '@FMV', '@FMV', '@ADVL', '@OBJ', '@SUBJ']} ,
	{187: ['@ADVL', '@FMV', ' P ', '@ADVL', '@SUBJ', '@OBJ', '@ADVL', 'Z Com', '@ADVL']} ,
	{188: ['@SUBJ', '@ADVL', '@NEG', '@FMV', '@ADVL']} ,
	{189: ['@SUBJ', '@ADVL', '@FMV', '@ADVL', '@PRD']} ,
	{190: ['@ADVL', '@PRD', '@FMV', '@OBJ', '@ADVL', '@ADVL', '@ADVL', '@ADVL', '@FMV', '@PRD', '@SUBJ']} ,
	{191: ['@ADVL', '@ADVL', '@FMV', '@ADVL', ' S ', '@SUBJ']} ,
	{192: ['@FMV', '@ADVL', '@OBJ', '@NEG', '@FMV', '@ADVL', '@ADVL']} ,
	{193: ['@ADVL', '@ADVL', '@SUBJ', '@ADVL', '@FMV', '@OBJ']} ,
	{194: ['@ADVL', '@ADVL', '@SUBJ', '@FMV', '@ADVL', '@OBJ']} ,
	{195: ['@FMV', '@OBJ', '@IMV']} ,
	{196: ['@OBJ', '@ADVL', '@ADVL']} ,
	{197: ['@OBJ', '@FMV', '@SUBJ', '@IMV']} ,
	{198: ['@ADVL', '@OBJ', '@SUBJ', '@FMV', '@ADVL', '@OBJ', '@ADVL', '@ADVL']} ,
	{199: ['@ADVL', 'Z Com', '@SUBJ', '@ADVL', '@FMV', '@OBJ']} ,
	{200: ['@ADVL', '@SUBJ', '@NEG', '@FMV', '@ADVL']} ,
	{201: ['@ADVL', '@OBJ', '@SUBJ', '@FMV', '@ADVL']} ,
	{202: ['@SUBJ', '@ADVL', '@NEG', '@FMV', '@PRD']} ,
	{203: ['@FMV', '@IMV', '@SUBJ', '@FMV', '@ADVL']} ,
	{204: ['@SUBJ', '@ADVL', '@IMV', '@FCV']} ,
	{205: ['Z Com', '@ADVL', '@ADVL', '@SUBJ', '@NEG', '@FMV']} ,
	{206: ['@ADVL', '@SUBJ', '@NEG', '@FMV', '@ADVL', '@ADVL']} ,
	{207: ['@SUBJ', '@ADVL', '@FMV', '@IMV', '@ADVL']} ,
	{208: ['@ADVL', '@NEG', '@FMV', '@ADVL', '@SUBJ', '@ADVL', '@PRD', '@SUBJ']} ,
	{209: ['@IMV', '@ADVL', '@ADVL', '@OBJ']} ,
	{210: ['@ADVL', '@ADVL', '@OBJ', '@IMV', '@ADVL']} ,
	{211: ['@SUBJ', '@ADVL', '@ADVL', '@FCV', '@IMV', '@ADVL']} ,
	{212: ['@OBJ', 'Z Com', '@SUBJ', '@FMV', '@PRD']} ,
	{213: ['@ADVL', '@SUBJ']} ,
	{214: ['@SUBJ', '@FMV', '@FMV']} ,
	{215: ['@ADVL', '@SUBJ', '@OBJ', '@FMV', 'Z Com', '@PRD']} ,
	{216: ['@ADVL', '@ADVL', '@ADVL', '@FCV', '@SUBJ', '@ADVL', '@IMV', '@OBJ']} ,
	{217: ['@SUBJ', '@ADVL', '@OBJ', '@NEG', '@FMV', '@OBJ', '@ADVL']} ,
	{218: ['@ADVL', 'Z Com', '@ADVL', '@FMV', '@PRD']} ,
	{219: ['@ADVL', '@IMV', '@SUBJ', '@FMV', '@PRD', '@ADVL']} ,
	{220: ['@FMV', '@PRD', '@SUBJ', '@OBJ', '@ADVL']} ,
	{221: ['@ADVL', '@PRD', '@FMV', '@ADVL', '@SUBJ']} ,
	{222: ['@ADVL', '@SUBJ', '@NEG', '@FMV', '@ADVL', '@ADVL', '@SUBJ']} ,
	{223: ['@IMV', '@OBJ', '@ADVL']} ,
	{224: ['@ADVL', '@ADVL', ' S ', '@SUBJ', '@FMV', '@OBJ']} ,
	{225: ['@FMV', '@OBJ', '@ADVL', '@OBJ', '@ADVL', '@ADVL', '@OBJ']} ,
	{226: ['@ADVL', '@ADVL', '@ADVL', '@ADVL', '@SUBJ', '@FMV']} ,
	{227: ['@ADVL', 'Z Com', 'ad', '@ADVL', '@SUBJ', '@FMV', '@ADVL']} ,
	{228: ['@SUBJ', '@IMV']} ,
	{229: ['ad', '@ADVL', '@SUBJ', '@FMV', '@OBJ']} ,
	{230: ['@OBJ', '@ADVL', '@FMV', '@ADVL', '@FMV', '@OBJ']} ,
	{231: ['@OBJ', '@ADVL', '@FMV', '@ADVL']} ,
	{232: ['@SUBJ', '@ADVL', 'Z Com', '@SUBJ', '@FMV', '@OBJ']} ,
	{233: ['@FMV', '@IMV', '@SUBJ', '@FMV', '@ADVL', '@ADVL', 'Z Com', '@OBJ', '@ADVL']} ,
	{234: ['@ADVL', '@SUBJ', '@ADVL', '@ADVL', '@SUBJ']} ,
	{235: ['@FMV', '@IMV', '@SUBJ', '@NEG', '@FMV', '@PRD']} ,
	{236: ['@ADVL', 'Z Com', '@SUBJ', '@FMV', '@OBJ', '@ADVL']} ,
	{237: ['@FMV', '@ADVL', '@OBJ']} ,
	{238: ['@SUBJ', 'Z Com', '@SUBJ', '@FMV']} ,
	{239: ['@ADVL', '@FCV', '@IMV', '@SUBJ']} ,
	{240: ['@ADVL', '@FMV', 'neg', '@SUBJ']} ,
	{241: ['Z Com', '@SUBJ', '@FMV', '@OBJ']} ,
	{242: ['@ADVL', '@ADVL', '@ADVL', '@OBJ', '@SUBJ', '@FMV']} ,
	{243: ['@ADVL', 'Z Com', '@ADVL']} ,
	{244: ['@NEG', '@FMV', '@OBJ']} ,
	{245: ['@ADVL', '@SUBJ', '@NEG', '@FMV', '@PRD']} ,
	{246: ['@PRD', '@ADVL', '@FMV', '@SUBJ']} ,
	{247: ['@ADVL', 'Z Com', '@SUBJ', '@FMV', '@OBJ', '@IMV', '@OBJ']} ,
	{248: ['@ADVL', '@ADVL']} ,
	{249: ['@ADVL', '@SUBJ', '@NEG', '@FMV']} ,
	{250: ['@ADVL', ' S ', '@SUBJ', '@FMV', '@OBJ', '@ADVL']} ,
	{251: ['ad', '@ADVL', '@SUBJ', '@FMV', '@OBJ', '@ADVL']} ,
	{252: ['@ADVL', '@SUBJ', '@FMV', '@OBJ', '@ADVL', '@OBJ', '@ADVL', '@OBJ']} ,
	{253: ['@SUBJ', '@ADVL', '@IMV', '@ADVL']} ,
	{254: ['@ADVL', '@OBJ', '@ADVL', '@SUBJ', '@FMV', '@OBJ']} ,
	{255: [' P ', '@ADVL', '@NEG', '@FMV', '@SUBJ', '@ADVL']} ,
	{256: ['@ADVL', 'Z Com']} ,
	{257: ['@ADVL', '@ADVL', 'Z Com', '@SUBJ', '@FMV', '@ADVL', '@ADVL', '@PRD']} ,
	{258: ['@SUBJ', '@ADVL', '@ADVL', '@OBJ', '@ADVL', 'Z Com', '@ADVL', '@SUBJ']} ,
	{259: ['@ADVL', '@ADVL', '@PRD', '@FMV', '@SUBJ']} ,
	{260: ['@ADVL', 'Z Com', '@ADVL', '@FMV', '@IMV', '@OBJ']} ,
	{261: ['@ADVL', '@ADVL', '@SUBJ', '@ADVL', '@ADVL', '@FMV']} ,
	{262: [' S ', '@SUBJ', '@FMV', '@OBJ']} ,
	{263: ['@ADVL', ' P ', 'Z Com', '@SUBJ', '@ADVL', '@FMV', '@SUBJ']} ,
	{264: ['@FMV', '@ADVL', '@SUBJ', '@NEG', '@FMV', '@ADVL', '@OBJ']} ,
	{265: ['@ADVL', '@ADVL', '@ADVL', '@FMV', '@SUBJ', '@ADVL', '@OBJ', '@ADVL']} ,
	{266: ['@ADVL', ' P ', 'Z Com', '@ADVL']} ,
	{267: ['@ADVL', '@ADVL', '@ADVL', '@ADVL', '@SUBJ', '@FMV', '@ADVL']} ,
	{268: ['@SUBJ', '@ADVL', '@FMV', '@PRD', '@FMV', '@PRD']} ,
	{269: ['@ADVL', '@OBJ', '@FMV', '@SUBJ', 'Z Com', '@ADVL', 'Z Com', '@ADVL', '@ADVL', 'Z Com', '@IMV', 'Z Com', '@IMV', 'Z Com', '@IMV', '@OBJ']} ,
	{270: ['@ADVL', '@ADVL', ' S ', '@SUBJ', '@FMV', '@PRD']} ,
	{271: ['@ADVL', '@ADVL', '@NEG', '@FMV', '@ADVL']} ,
	{272: ['@ADVL', '@ADVL', '@OBJ', '@SUBJ', '@ADVL', '@FMV']} ,
	{273: ['@SUBJ', '@ADVL', '@SUBJ', '@FMV', '@OBJ']} ,
	{274: ['@ADVL', '@OBJ', '@FMV', '@ADVL', '@SUBJ', '@ADVL']} ,
	{275: ['@ADVL', '@OBJ', '@FMV', '@OBJ', '@ADVL', '@OBJ', 'Z Com', '@ADVL', '@ADVL', ' P ', '@ADVL']} ,
	{276: ['@FMV', '@IMV', '@SUBJ', '@FMV', '@ADVL', '@OBJ']} ,
	{277: ['@ADVL', '@ADVL', '@ADVL', '@FMV', '@PRD']} ,
	{278: ['@SUBJ', '@ADVL', '@OBJ', 'Z Com', '@SUBJ', '@FMV']} ,
	{279: ['@SUBJ', '@ADVL', '@NEG', '@FMV', '@ADVL', '@PRD']} ,
	{280: ['@ADVL', '@OBJ', 'Z Com', '@FMV', '@ADVL']} ,
	{281: ['@OBJ', '@ADVL', '@SUBJ', '@IMV', '@OBJ', '@PRD']} ,
	{282: ['@OBJ', '@SUBJ', '@FCV', '@IMV']} ,
	{283: ['ad', '@ADVL', '@ADVL', '@SUBJ', '@FMV', '@PRD']} ,
	{284: ['@ADVL', '@SUBJ', '@FCV', '@IMV', '@PRD']} ,
	{285: ['Z Com', '@SUBJ', '@NEG', '@FMV', '@OBJ', '@ADVL']} ,
	{286: ['@FMV', '@ADVL', '@SUBJ', 'Z Com', '@ADVL', 'Z Com', '@ADVL', '@ADVL', '@ADVL', '@ADVL']} ,
	{287: ['@ADVL', '@SUBJ', '@FMV', '@SUBJ', '@FMV', '@OBJ']} ,
	{288: ['@SUBJ', '@FCV', '@ADVL', '@IMV']} ,
	{289: ['ad', '@ADVL', '@SUBJ', '@ADVL', '@FMV']} ,
	{290: ['@FMV', '@IMV', '@PRD']} ,
	{291: ['@OBJ', '@FMV', '@OBJ', '@ADVL', '@ADVL']} ,
	{292: ['@OBJ', '@SUBJ']} ,
	{293: ['@OBJ', '@SUBJ', '@ADVL', '@FCV', '@IMV']} ,
	{294: ['@OBJ', '@SUBJ', '@OBJ', '@FMV']} ,
	{295: ['@ADVL', ' S ', '@OBJ', '@FMV', '@ADVL', '@SUBJ']} ,
	{296: [' P ', '@ADVL', '@SUBJ', '@FMV', '@ADVL', '@OBJ', '@ADVL']} ,
	{297: ['@OBJ', '@IMV', 'Z Com', '@IMV', '@OBJ']} ,
	{298: ['@ADVL', '@ADVL', 'Z Com', '@ADVL', '@FMV', '@SUBJ']} ,
	{299: ['@OBJ', '@ADVL', '@ADVL', '@FMV', '@OBJ', '@ADVL']} ,
	{300: ['@ADVL', 'Z Com', '@ADVL', '@FMV']} ,
	{301: ['@ADVL', '@IMV']} ,
	{302: ['@OBJ', '@ADVL', '@ADVL', '@ADVL', '@FMV', '@IMV']} ,
	{303: ['@ADVL', 'Z Com', '@OBJ', '@FMV', '@SUBJ', 'Z Com', 'Z Com', '@SUBJ']} ,
	{304: ['@ADVL', '@ADVL', 'Z Com', '@SUBJ', '@NEG', '@FCV', '@OBJ', '@IMV']} ,
	{305: ['@ADVL', '@NEG', '@FMV', '@SUBJ', '@ADVL', '@ADVL', '@ADVL']} ,
	{306: ['@SUBJ', '@OBJ', '@FMV', '@ADVL', '@SUBJ']} ,
	{307: ['@ADVL', '@SUBJ', '@FMV', '@IMV', '@ADVL', '@ADVL']} ,
	{308: ['Z Com', '@SUBJ', '@NEG', '@FMV', '@ADVL']} ,
	{309: ['@OBJ', '@FMV', 'ad', '@ADVL']} ,
	{310: ['Z Com', '@ADVL', '@FMV', '@ADVL']} ,
	{311: ['@ADVL', '@SUBJ', '@FMV', '@OBJ', 'Z Com', '@OBJ', 'Z Com', '@OBJ', 'Z Com', '@OBJ', '@ADVL']} ,
	{312: [' P ', '@ADVL', '@FMV', '@ADVL']} ,
	{313: ['@OBJ', '@ADVL', '@SUBJ', '@FMV', '@IMV']} ,
	{314: ['@ADVL', '@FCV', '@IMV', '@SUBJ', '@ADVL', ' S ']} ,
	{315: ['@SUBJ', '@ADVL', '@NEG', '@FMV', '@SUBJ', '@ADVL']} ,
	{316: ['@OBJ', '@SUBJ', '@FMV', '@OBJ', '@ADVL', '@ADVL']} ,
	{317: ['@ADVL', ' P ', '@ADVL', '@FMV', '@PRD', '@SUBJ']} ,
	{318: ['@ADVL', '@ADVL', '@SUBJ', '@FMV', '@OBJ', '@ADVL']} ,
	{319: ['@ADVL', '@SUBJ', '@ADVL', '@FMV', '@SUBJ']} ,
	{320: ['@ADVL', '@ADVL', '@FMV', '@SUBJ', '@ADVL', '@OBJ']} ,
	{321: ['@ADVL', '@FMV', '@IMV', '@ADVL', '@SUBJ']} ,
	{322: [' P ', '@ADVL', '@FMV', '@ADVL', '@SUBJ']} ,
	{323: ['@ADVL', ' P ', '@ADVL', '@SUBJ', '@FMV']} ,
	{324: ['@SUBJ', '@ADVL', 'Z Com', '@ADVL', '@FMV', '@SUBJ']} ,
	{325: ['@ADVL', ' S ', '@FMV', '@ADVL']} ,
	{326: ['@ADVL', '@FCV', '@IMV']} ,
	{327: ['@ADVL', ' S ', '@ADVL', '@FMV', '@ADVL', '@ADVL', '@SUBJ']} ,
	{328: ['@ADVL', '@ADVL', '@ADVL', 'Z Com', '@SUBJ', '@ADVL']} ,
	{329: ['@FMV', '@IMV', '@SUBJ']} ,
	{330: ['@OBJ', '@ADVL', '@ADVL', '@FMV', '@OBJ', '@ADVL', '@ADVL']} ,
	{331: ['@ADVL', '@PRD', '@IMV', '@ADVL', '@SUBJ', '@FMV', '@ADVL']} ,
	{332: ['@ADVL', '@SUBJ', '@FMV', '@PRD', '@ADVL', '@ADVL']} ,
	{333: ['@OBJ', '@ADVL', '@IMV']} ,
	{334: ['@FMV', '@IMV', '@ADVL']} ,
	{335: ['@ADVL', '@ADVL', '@SUBJ', '@PRD', '@ADVL', '@ADVL']} ,
	{336: ['@SUBJ', '@FMV', '@ADVL', '@PRD']} ,
	{337: ['@ADVL', '@FMV', '@PRD', '@OBJ', '@SUBJ']} ,
	{338: ['@ADVL', '@SUBJ', '@NEG', '@FMV', '@PRD', '@ADVL']} ,
	{339: ['@ADVL', '@SUBJ', '@FCV']} ,
	{340: ['ad', '@ADVL', '@SUBJ', '@FMV', '@IMV']} ,
	{341: ['@SUBJ', '@FMV', '@SUBJ', '@ADVL', '@ADVL', '@FMV']} ,
	{342: ['@ADVL', '@FMV', '@IMV', '@SUBJ']} ,
	{343: ['@FMV', '@ADVL', '@SUBJ', '@OBJ']} ,
	{344: ['@ADVL', ' P ', '@ADVL', '@FMV', '@ADVL', '@SUBJ']} ,
	{345: ['@SUBJ', '@FMV', '@ADVL', '@PRD', '@ADVL']} ,
	{346: ['@ADVL', '@ADVL', '@FMV', 'ad', '@ADVL']} ,
	{347: ['@ADVL', '@ADVL', '@ADVL', '@ADVL', '@FMV', '@SUBJ']} ,
	{348: ['@ADVL', 'Z Com', '@ADVL', '@FMV', '@OBJ', '@ADVL', '@OBJ', 'Z Com', '@OBJ', '@ADVL', '@ADVL', 'Z Com', '@OBJ']} ,
	{349: ['@ADVL', '@ADVL', '@ADVL', '@ADVL', '@SUBJ', '@NEG', '@FMV', '@OBJ']} ,
	{350: ['@ADVL', '@SUBJ', '@NEG', '@FMV', '@ADVL', '@ADVL', '@ADVL']} ,
	{351: ['@SUBJ', '@ADVL', '@FMV', '@ADVL', '@ADVL', '@FMV', '@ADVL', '@PRD']} ,
	{352: ['@ADVL', '@SUBJ', '@NEG', '@FMV', '@ADVL', '@OBJ', '@ADVL']} ,
	{353: ['@FMV', '@ADVL', '@ADVL', '@FMV', '@ADVL', '@IMV', '@IMV', '@ADVL', '@OBJ']} ,
	{354: ['@ADVL', ' P ', '@SUBJ', '@FMV', '@ADVL', '@ADVL']} ,
	{355: ['@OBJ', 'Z Com', '@ADVL', '@FMV', '@PRD']} ,
	{356: ['Z Com', ' P ', '@ADVL', '@FMV', '@SUBJ', '@ADVL']} ,
	{357: ['@ADVL', 'Z Com', '@PRD', '@ADVL', '@OBJ', '@SUBJ', '@ADVL', '@FMV', '@PRD']} ,
	{358: ['@SUBJ', 'Z Com', '@OBJ']} ,
	{359: ['@IMV', '@ADVL', '@NEG', '@FMV', '@ADVL']} ,
	{360: ['@ADVL', '@OBJ', '@FMV', '@OBJ', '@SUBJ']} ,
	{361: ['@FMV', '@IMV', '@SUBJ', '@FMV', '@OBJ', '@ADVL']} ,
	{362: ['@ADVL', '@ADVL', '@SUBJ', '@FMV', '@ADVL', '@ADVL', '@SUBJ', '@FMV', '@OBJ']} ,
	{363: ['@OBJ', '@SUBJ', '@NEG', '@FMV']} ,
	{364: ['@ADVL', '@PRD', '@FMV', '@ADVL']} ,
	{365: ['@ADVL', '@ADVL', '@FMV', '@ADVL', '@ADVL']} ,
	{366: ['@OBJ', '@ADVL', '@ADVL', '@FMV', '@ADVL', '@ADVL']} ,
	{367: [' S ', '@ADVL', '@SUBJ', '@FMV', '@PRD']} ,
	{368: ['@SUBJ', '@IMV', '@ADVL', '@SUBJ']} ,
	{369: ['@ADVL', ' P ', '@SUBJ', '@ADVL', '@FMV']} ,
	{370: ['@SUBJ', '@ADVL', '@FMV', '@ADVL', '@ADVL', '@OBJ']} ,
	{371: ['@ADVL', 'Z Com', '@OBJ', '@FMV', '@SUBJ']} ,
	{372: ['Z Com', '@ADVL', '@FMV', '@SUBJ', '@ADVL', 'Z Com', '@ADVL', '@ADVL', '@ADVL']} ,
	{373: ['@ADVL', '@SUBJ', '@OBJ', '@FMV', '@ADVL', '@ADVL', '@OBJ']} ,
	{374: ['@OBJ', '@ADVL', 'Z Com', '@ADVL', 'Z Com', '@SUBJ', '@NEG', '@FMV']} ,
	{375: ['@ADVL', '@OBJ', '@ADVL', '@SUBJ', '@FMV']} ,
	{376: ['Z Com', '@ADVL', '@FMV', '@OBJ']} ,
	{377: ['@OBJ', '@ADVL', 'Z Com', '@OBJ', '@FMV', '@IMV']} ,
	{378: ['@ADVL', 'Z Com', '@SUBJ', '@FMV', 'ad', '@ADVL']} ,
	{379: ['Z Com', '@PRD', '@FMV', '@SUBJ', '@PRD']} ,
	{380: ['@FMV', '@ADVL', '@ADVL', '@ADVL', 'Z Com', '@ADVL']} ,
	{381: ['@IMV', '@SUBJ']} ,
	{382: ['@ADVL', ' P ', '@FMV', '@IMV', '@OBJ', '@ADVL']} ,
	{383: ['@SUBJ', '@ADVL', '@FCV', '@IMV']} ,
	{384: ['@ADVL', '@ADVL', '@SUBJ', '@FMV', '@SUBJ', '@FMV', '@OBJ']} ,
	{385: ['@ADVL', '@ADVL', '@SUBJ', '@OBJ', '@FMV', '@IMV']} ,
	{386: ['@FMV', '@ADVL', '@ADVL', '@SUBJ']} ,
	{387: ['@ADVL', ' P ', '@NEG', '@FMV', '@SUBJ']} ,
	{388: ['@FMV', '@IMV', '@OBJ', '@FMV']} ,
	{389: ['@ADVL', '@ADVL', '@FMV', '@PRD', '@ADVL']} ,
	{390: ['@ADVL', '@FMV', '@PRD', '@ADVL']} ,
	{391: ['@ADVL', '@IMV', '@PRD', '@FMV', '@OBJ', '@SUBJ']} ,
	{392: ['@OBJ', '@ADVL', '@ADVL', '@FMV', '@FMV']} ,
	{393: ['@FMV', '@IMV', '@ADVL', '@PRD', '@OBJ', '@ADVL', '@NEG', '@FMV']} ,
	{394: ['@SUBJ', '@FMV', '@FMV', '@ADVL', '@ADVL', '@OBJ']} ,
	{395: ['@PRD', '@FCV', '@IMV', '@OBJ', '@PRD']} ,
	{396: ['@ADVL', '@ADVL', '@ADVL', '@FMV', '@ADVL', '@SUBJ']} ,
	{397: ['@ADVL', '@SUBJ', '@ADVL', '@SUBJ']} ,
	{398: ['@IMV', '@FMV']} ,
	{399: ['@ADVL', ' P ', '@SUBJ', '@FMV', '@PRD']} ,
	{400: ['@SUBJ', '@ADVL', 'Z Com', '@ADVL', '@ADVL', '@ADVL', '@FMV', '@OBJ', '@ADVL', '@SUBJ', '@ADVL', '@ADVL']} ,
	{401: ['@ADVL', '@ADVL', '@ADVL', '@SUBJ', '@FMV', '@ADVL']} ,
	{402: ['@ADVL', '@ADVL', '@SUBJ', '@NEG', '@FMV', '@OBJ']} ,
	{403: ['@NEG', '@FMV']} ,
	{404: ['@ADVL', '@FMV', '@FMV', '@OBJ', '@ADVL']} ,
	{405: ['ad', '@ADVL', '@FMV', '@ADVL', '@ADVL', '@IMV', '@ADVL']} ,
	{406: ['@OBJ', '@ADVL', '@FMV', '@IMV', '@OBJ']} ,
	{407: ['@FMV', '@ADVL', '@FMV', '@ADVL', '@IMV', '@OBJ', '@FMV', '@OBJ']} ,
	{408: ['@FMV', '@ADVL', '@ADVL', 'Z Com', '@ADVL']} ,
	{409: ['@ADVL', '@SUBJ', '@FMV', '@OBJ', '@ADVL', 'Z Com']} ,
	{410: ['@ADVL', '@SUBJ', '@NEG', '@FMV', '@OBJ']} ,
	{411: [' P ', '@ADVL', '@SUBJ', '@FMV', 'ad', '@ADVL']} ,
	{412: ['@ADVL', 'Z Com', '@SUBJ', '@FMV', '@OBJ', '@IMV', '@ADVL', '@ADVL']} ,
	{413: ['@ADVL', '@ADVL', '@SUBJ', '@FMV', '@IMV', '@OBJ', '@ADVL']} ,
	{414: ['Z Com', '@ADVL', '@FMV', '@IMV', '@SUBJ', '@ADVL']} ,
	{415: ['@ADVL', '@ADVL', '@SUBJ', '@FMV', '@OBJ', ' P ', '@ADVL']} ,
	{416: ['@SUBJ', '@ADVL', '@FMV', '@ADVL', '@OBJ']} ,
	{417: ['@ADVL', '@SUBJ', '@PRD', '@ADVL']} ,
	{418: ['Z Com', '@ADVL', '@ADVL', '@OBJ', '@FMV', '@ADVL']} ,
	{419: ['@ADVL', '@ADVL', '@SUBJ', '@FMV', '@SUBJ']} ,
	{420: ['@FMV', '@IMV', '@SUBJ', '@OBJ']} ,
	{421: ['@SUBJ', '@OBJ', '@FMV', '@OBJ', '@FMV', '@ADVL']} ,
	{422: ['@ADVL', '@ADVL', '@FMV', '@ADVL', ' S ']} ,
	{423: ['@FMV', '@OBJ', '@ADVL', '@SUBJ', '@FMV', '@FMV', '@OBJ', '@ADVL']} ,
	{424: ['@FMV', '@ADVL', '@FMV']} ,
	{425: ['ad', '@ADVL', '@FMV', '@ADVL', 'Z Com', '@ADVL', '@SUBJ']} ,
	{426: ['@ADVL', '@OBJ', '@FMV', '@IMV', '@SUBJ']} ,
	{427: ['@FMV', '@OBJ', '@ADVL', '@ADVL']} ,
	{428: ['@ADVL', '@FMV', '@IMV', '@SUBJ', 'Z Com', '@ADVL']} ,
	{429: ['@FCV', '@IMV']} ,
	{430: ['ad', '@ADVL', '@SUBJ', '@IMV', '@FMV']} ,
	{431: ['@ADVL', '@SUBJ', ' S ', 'Z Com', '@OBJ', '@FMV', '@OBJ']} ,
	{432: ['@ADVL', '@SUBJ', 'Z Com', '@SUBJ', '@FMV', '@PRD']} ,
	{433: ['@SUBJ', '@ADVL', '@ADVL', '@ADVL', '@SUBJ', '@FMV', '@ADVL', '@OBJ']} ,
	{434: [' P ', '@ADVL', '@ADVL', '@FMV', '@SUBJ', ' P ', '@ADVL', '@ADVL', '@SUBJ']} ,
	{435: ['@SUBJ', '@ADVL', '@FMV', '@ADVL', '@SUBJ', '@FMV', '@PRD']} ,
	{436: ['@ADVL', '@SUBJ', '@NEG', '@FMV', '@ADVL', '@OBJ', '@FMV']} ,
	{437: ['@ADVL', 'Z Com', '@ADVL', '@ADVL', '@IMV', '@ADVL']} ,
	{438: ['@ADVL', '@ADVL', 'Z Com', '@ADVL', '@ADVL', '@NEG', '@FMV', '@ADVL', '@SUBJ']} ,
	{439: ['@OBJ', '@ADVL', '@FCV', '@IMV', '@ADVL', '@SUBJ']} ,
	{440: ['@ADVL', '@ADVL', '@FMV', '@PRD', 'Z Com', '@PRD', '@SUBJ']} ,
	{441: ['@OBJ', '@FMV', '@SUBJ', '@ADVL', '@ADVL']} ,
	{442: ['Z Com', '@SUBJ', '@NEG', '@FMV', '@ADVL', '@SUBJ', '@FMV']} ,
	{443: ['@ADVL', '@ADVL', ' P ', '@SUBJ', '@FMV', '@OBJ']} ,
	{444: ['@OBJ', '@FCV', '@IMV', '@ADVL', '@SUBJ']} ,
	{445: ['@ADVL', '@ADVL', '@FMV', '@PRD', '@ADVL', '@ADVL']} ,
	{446: ['@OBJ', '@FMV', '@SUBJ', '@ADVL', '@ADVL', ' S ']} ,
	{447: ['@ADVL', '@PRD', '@ADVL']} ,
	{448: ['@SUBJ', '@FMV', '@OBJ', '@ADVL']} ,
	{449: ['@ADVL', '@ADVL', ' P ', '@ADVL', '@FMV', '@SUBJ', 'Z Com', '@ADVL', '@SUBJ']} ,
	{450: ['@OBJ', '@ADVL', '@FMV', '@OBJ', '@ADVL']} ,
	{451: ['@ADVL', '@ADVL', '@IMV', '@FMV']} ,
	{452: ['@IMV', '@ADVL', '@SUBJ', '@FMV', '@OBJ']} ,
	{453: ['@IMV', '@OBJ', 'Z Com', '@SUBJ', '@FMV', '@OBJ']} ,
	{454: ['@ADVL', '@NEG', '@FMV', '@IMV', '@SUBJ', '@ADVL', '@ADVL', '@ADVL', '@FMV', '@ADVL']} ,
	{455: ['@ADVL', '@SUBJ', '@FCV', '@IMV', '@ADVL', '@ADVL', '@OBJ', '@FMV', '@ADVL', '@ADVL']} ,
	{456: ['@ADVL', '@ADVL', '@FMV', '@SUBJ', 'Z Com', '@SUBJ']} ,
	{457: ['@OBJ', '@SUBJ', '@FMV', '@OBJ', '@IMV', '@ADVL']} ,
	{458: ['ad', ' P ', '@ADVL', '@ADVL', '@FMV', '@PRD']} ,
	{459: ['@SUBJ', '@OBJ', '@FMV', '@ADVL', '@IMV', '@OBJ']} ,
	{460: ['@OBJ', '@ADVL', '@FMV', '@ADVL', '@ADVL']} ,
	{461: ['ad', '@ADVL', '@SUBJ', '@FMV', '@ADVL', '@OBJ', '@ADVL']} ,
	{462: ['@ADVL', ' S ', '@SUBJ', '@FMV', '@SUBJ']} ,
	{463: ['@ADVL', '@ADVL', '@ADVL', '@SUBJ', '@ADVL', '@FMV', '@PRD', '@IMV', '@SUBJ', '@ADVL']} ,
	{464: [' P ', '@ADVL', '@SUBJ', '@FCV', '@IMV', '@OBJ']} ,
	{465: ['@ADVL', '@SUBJ', '@FMV', '@OBJ', '@FMV', '@PRD', 'Z Com', '@PRD']} ,
	{466: [' P ', '@ADVL', '@ADVL', '@FMV', '@ADVL', '@SUBJ', '@FMV', '@PRD']} ,
	{467: ['@ADVL', '@ADVL', '@ADVL', '@ADVL', '@ADVL', '@FMV', '@ADVL']} ,
	{468: ['@FMV', '@PRD', '@ADVL', '@SUBJ']} ,
	{469: ['ad', '@ADVL', '@FMV', '@OBJ', '@ADVL']} ,
	{470: ['@ADVL', '@ADVL', '@ADVL', '@ADVL', ' S ', '@ADVL', '@FMV', '@SUBJ']} ,
	{471: ['@OBJ', '@ADVL', '@SUBJ', '@FMV', '@ADVL', '@IMV']} ,
	{472: ['@PRD', '@FMV', '@FMV', '@ADVL', '@OBJ', '@FMV', '@ADVL', '@FMV', '@PRD']} ,
	{473: ['Z Com', '@SUBJ', '@NEG', '@FMV', '@ADVL', '@OBJ', '@ADVL']} ,
	{474: ['@SUBJ', '@ADVL', '@ADVL', '@NEG', '@FMV']} ,
	{475: ['@ADVL', '@SUBJ', '@FMV', '@OBJ', '@ADVL', '@ADVL', '@ADVL', '@ADVL']} ,
	{476: ['@ADVL', '@FMV', '@PRD', 'Z Com', '@ADVL']} ,
	{477: ['@ADVL', 'Z Com', '@ADVL', '@FMV', '@FMV', '@ADVL']} ,
	{478: ['@ADVL', '@SUBJ', '@ADVL', '@NEG', '@FMV', '@OBJ', '@ADVL', '@ADVL']} ,
	{479: ['@ADVL', 'Z Com', '@ADVL', '@ADVL', '@SUBJ', '@FMV', '@PRD']} ,
	{480: ['@SUBJ', '@ADVL', '@FMV', '@ADVL', '@IMV', '@OBJ']} ,
	{481: ['@OBJ', '@ADVL', '@ADVL', '@SUBJ', '@FMV', '@IMV']} ,
	{482: ['@ADVL', '@ADVL', '@NEG', '@FMV', '@ADVL', '@PRD']} ,
	{483: ['@ADVL', ' S ', '@SUBJ', '@FMV', '@IMV', '@OBJ']} ,
	{484: ['@ADVL', ' S ', '@SUBJ', '@ADVL', '@FMV', '@ADVL', '@ADVL']} ,
	{485: ['@ADVL', '@SUBJ', '@ADVL', '@IMV', '@ADVL', '@SUBJ', '@ADVL']} ,
	{486: ['@FMV', 'Z Com', ' P ', '@OBJ', 'Z Com', ' P ', '@FMV', '@PRD']} ,
	{487: ['@SUBJ', '@ADVL', '@ADVL', '@ADVL', '@FCV', '@IMV']} ,
	{488: ['@ADVL', '@ADVL', '@ADVL', '@ADVL', '@FMV']} ,
	{489: ['@ADVL', 'Z Com', '@FMV', '@IMV', '@ADVL', '@ADVL', '@ADVL', '@IMV', '@OBJ']} ,
	{490: ['@NEG', '@FMV', '@ADVL', '@ADVL', '@SUBJ', '@FMV']} ,
	{491: ['@ADVL', '@ADVL', '@FMV', '@SUBJ', '@ADVL', '@OBJ', '@SUBJ']} ,
	{492: ['@ADVL', '@ADVL', '@FMV', '@SUBJ', '@ADVL', '@ADVL', '@SUBJ']} ,
	{493: ['@FMV', '@FMV', '@OBJ']} ,
	{494: ['@FMV', '@OBJ', '@ADVL', '@ADVL', '@SUBJ']} ,
	{495: ['@ADVL', ' S ', '@FMV']} ,
	{496: ['@ADVL', '@SUBJ', '@FMV', '@SUBJ', '@FMV', '@ADVL']} ,
	{497: ['@SUBJ', 'Z Com']} ,
	{498: ['@ADVL', '@OBJ', '@SUBJ', '@FCV', '@IMV', '@ADVL']} ,
	{499: ['@OBJ', '@ADVL', '@SUBJ', '@FMV', '@IMV', '@ADVL']} ,
	{500: ['@ADVL', '@SUBJ', 'Z Com', '@ADVL', '@FMV', '@ADVL']} ,
	{501: ['Z Com', '@FMV', '@PRD', '@SUBJ', '@ADVL', '@ADVL', '@OBJ', '@ADVL', ' S ']} ,
	{502: [' P ', '@ADVL', '@SUBJ', '@FMV', '@ADVL', '@OBJ']} ,
	{503: ['@ADVL', '@SUBJ', 'Z Com', '@FMV', '@OBJ']} ,
	{504: ['Z Com', 'Z Com', '@ADVL', '@SUBJ', '@FMV', '@PRD']} ,
	{505: ['@SUBJ', '@FMV', '@OBJ']} ,
	{506: ['@SUBJ', '@FMV', 'ad', '@ADVL', '@ADVL', '@ADVL']} ,
	{507: ['@FMV', '@IMV', '@SUBJ', '@FMV', '@OBJ']} ,
	{508: ['@ADVL', '@OBJ', '@SUBJ', '@FMV', '@OBJ']} ,
	{509: ['@ADVL', ' P ', '@SUBJ', '@FMV', '@ADVL']} ,
	{510: ['@FMV', '@SUBJ', 'Z Com']} ,
	{511: ['@ADVL', 'Z Com', '@OBJ', '@NEG', '@FMV', '@SUBJ']} ,
	{512: ['ad', '@SUBJ', '@ADVL', '@FMV', '@ADVL', '@ADVL', '@ADVL', '@PRD']} ,
	{513: ['@ADVL', '@IMV', 'Z Com', '@IMV', '@ADVL']} ,
	{514: ['@ADVL', ' S ', '@ADVL', '@FMV', '@SUBJ', '@ADVL']} ,
	{515: ['@OBJ', 'Z Com', '@OBJ', 'Z Com', '@OBJ']} ,
	{516: ['@ADVL', '@ADVL', '@FMV', '@ADVL', '@ADVL', '@OBJ', '@ADVL', '@ADVL']} ,
	{517: ['@SUBJ', 'Z Com', '@SUBJ', '@PRD', '@FMV', '@ADVL']} ,
	{518: ['Z Com', '@OBJ', '@FMV', '@ADVL', ' S ']} ,
	{519: [' S ', '@FMV', '@ADVL']} ,
	{520: ['@ADVL', '@SUBJ', '@ADVL', 'Z Fst', '@FMV', '@OBJ']} ,
	{521: ['@ADVL', 'Z Com', '@SUBJ', '@NEG', '@FMV']} ,
	{522: ['@NEG', '@FMV', '@IMV']} ,
	{523: ['@NEG', '@FMV', '@SUBJ', '@ADVL', '@SUBJ', '@ADVL', '@OBJ']} ,
	{524: ['@ADVL', '@OBJ', '@FMV', '@IMV']} ,
	{525: ['@ADVL', '@NEG', '@FMV', '@IMV', '@ADVL', '@ADVL']} ,
	{526: ['@ADVL', ' P ', '@ADVL', '@ADVL', '@SUBJ', '@FMV', '@ADVL']} ,
	{527: ['@ADVL', 'Z Com', '@SUBJ', '@FMV', '@OBJ']} ,
	{528: ['@ADVL', 'Z Com', '@PRD', '@FMV', '@SUBJ']} ,
	{529: ['@ADVL', '@NEG', '@FMV', '@ADVL', '@SUBJ']} ,
	{530: ['@SUBJ', '@ADVL', '@FCV', '@IMV', '@ADVL']} ,
	{531: ['@ADVL', '@FMV', '@IMV', '@ADVL']} ,
	{532: ['@SUBJ', '@FMV', '@SUBJ', '@ADVL']} ,
	{533: ['@ADVL', '@NEG', '@FMV', '@ADVL', '@ADVL', ' S ', '@ADVL', '@SUBJ']} ,
	{534: ['@ADVL', '@ADVL', '@SUBJ', '@FMV', '@OBJ', 'Z Com', '@OBJ']} ,
	{535: ['@FMV', '@SUBJ', '@ADVL', '@ADVL', '@SUBJ', '@ADVL']} ,
	{536: ['Z Com', '@ADVL', '@NEG', '@FMV', '@ADVL']} ,
	{537: ['@ADVL', '@ADVL', '@ADVL', '@FMV']} ,
	{538: ['@ADVL', '@ADVL', '@FMV', '@SUBJ', '@OBJ']} ,
	{539: ['@OBJ', 'Z Com', '@SUBJ', '@FMV']} ,
	{540: ['@ADVL', '@SUBJ', '@FCV', '@IMV', '@ADVL', '@ADVL']} ,
	{541: ['@ADVL', '@NEG', '@FMV', '@PRD', '@ADVL', '@SUBJ', '@ADVL', '@SUBJ']} ,
	{542: ['@ADVL', '@SUBJ', '@FMV', '@PRD', '@FMV', '@ADVL', '@ADVL']} ,
	{543: ['@ADVL', '@FMV', '@SUBJ', 'Z Com', '@SUBJ']} ,
	{544: ['@ADVL', ' P ', '@ADVL', '@SUBJ', '@FMV', '@ADVL']} ,
	{545: ['@FCV', '@IMV', '@ADVL']} ,
	{546: ['@ADVL', '@ADVL', '@NEG', '@FMV', '@ADVL', '@ADVL']} ,
	{547: ['@ADVL', '@ADVL', '@FMV', ' S ', '@OBJ']} ,
	{548: ['@SUBJ', '@ADVL', '@FMV', '@ADVL', '@OBJ', 'Z Com', ' P ', '@ADVL', '@SUBJ', '@FMV', '@PRD']} ,
	{549: [' P ', '@ADVL', '@SUBJ', '@FMV', '@OBJ', '@ADVL']} ,
	{550: ['@ADVL', 'Z Com', '@ADVL', '@FMV', '@OBJ', '@SUBJ']} ,
	{551: ['@ADVL', 'Z Com', '@ADVL', 'Z Com', '@OBJ', '@FMV', '@OBJ', '@SUBJ']} ,
	{552: ['@ADVL', '@ADVL', '@SUBJ', '@ADVL', 'Z Com', '@SUBJ', '@FMV', '@FMV', '@OBJ']} ,
	{553: ['@ADVL', '@SUBJ', 'Z Com', '@SUBJ', '@FMV', '@ADVL', '@ADVL']} ,
	{554: ['@ADVL', 'Z Com', '@OBJ', '@FMV', '@IMV', '@OBJ']} ,
	{555: ['@ADVL', '@SUBJ', '@FMV', '@ADVL', '@ADVL', '@OBJ']} ,
	{556: ['@ADVL', '@SUBJ', '@ADVL', '@FMV', '@ADVL', '@ADVL']} ,
	{557: ['@ADVL', '@OBJ', '@FMV']} ,
	{558: ['@FMV', '@IMV', '@SUBJ', '@ADVL', '@OBJ', '@ADVL']} ,
	{559: ['@SUBJ', '@FMV', '@PRD', '@ADVL']} ,
	{560: ['@OBJ', 'Z Com', '@FMV']} ,
	{561: ['@ADVL', '@ADVL', '@NEG', '@FMV', '@SUBJ', '@ADVL', '@ADVL']} ,
	{562: ['@ADVL', '@ADVL', '@FMV', '@ADVL', '@SUBJ', 'Z Com', '@SUBJ', 'Z Com', '@SUBJ']} ,
	{563: ['@ADVL', 'Z Com', '@ADVL', '@ADVL', '@FMV']} ,
	{564: ['@ADVL', '@OBJ', '@ADVL']} ,
	{565: ['ad', '@ADVL', '@ADVL', '@OBJ']} ,
	{566: ['@NEG', '@FMV', '@ADVL', '@SUBJ', '@OBJ', '@ADVL', 'Z Com', '@SUBJ', '@ADVL', '@ADVL', '@SUBJ']} ,
	{567: ['@ADVL', '@SUBJ', 'Z Com', '@ADVL', '@SUBJ', '@FMV', '@ADVL', '@OBJ']} ,
	{568: ['@ADVL', '@ADVL', '@ADVL', '@SUBJ', '@FMV', '@IMV']} ,
	{569: ['@OBJ', '@ADVL', '@ADVL', '@FMV', '@ADVL', '@ADVL', '@FMV']} ,
	{570: ['@SUBJ', '@FMV', '@FMV', '@OBJ']} ,
	{571: ['@PRD', '@ADVL', '@SUBJ', '@FMV', '@PRD', '@FMV', '@PRD']} ,
	{572: ['@IMV', '@ADVL', '@OBJ']} ,
	{573: ['@SUBJ', '@OBJ']} ,
	{574: [' P ', '@ADVL', '@SUBJ', '@FMV', '@PRD', '@ADVL', '@PRD']} ,
	{575: ['@OBJ', '@SUBJ', '@FMV', '@ADVL', '@ADVL']} ,
	{576: ['neg', '@SUBJ', '@PRD', '@FMV', '@SUBJ', '@FMV', '@ADVL']} ,
	{577: ['@SUBJ', '@ADVL', '@FMV', '@SUBJ', 'Z Com', '@SUBJ']} ,
	{578: ['@OBJ', '@IMV', '@ADVL']} ,
	{579: ['@PRD', '@FMV', '@OBJ', '@SUBJ', '@FMV']} ,
	{580: ['@ADVL', ' S ', '@ADVL', '@SUBJ', '@ADVL', '@FMV', '@ADVL']} ,
	{581: ['@ADVL', '@SUBJ', '@FCV', '@IMV', '@ADVL', '@PRD']} ,
	{582: ['@OBJ', '@FMV', '@IMV', '@FMV', '@ADVL', '@ADVL']} ,
	{583: ['@FMV', 'Z Com', ' S ', 'Z Com', ' S ', '@SUBJ', '@FCV', '@IMV']} ,
	{584: [' P ', '@ADVL', '@SUBJ', '@FMV', '@IMV', '@OBJ']} ,
	{585: ['Z Com', '@FMV', '@PRD']} ,
	{586: [' P ', '@ADVL', '@ADVL', '@ADVL', '@FMV']} ,
	{587: ['@ADVL', '@FMV', '@IMV', '@OBJ', '@ADVL']} ,
	{588: ['@ADVL', '@IMV', '@ADVL', '@FMV', '@SUBJ']} ,
	{589: ['@ADVL', '@SUBJ', 'Z Com', '@SUBJ', '@FMV', '@ADVL', 'Z Com', ' P ', '@ADVL', 'Z Com', ' P ', '@FMV', '@IMV']} ,
	{590: ['@ADVL', 'ad', '@ADVL', '@FMV', '@ADVL']} ,
	{591: ['@SUBJ', '@OBJ', '@FMV', '@ADVL', '@OBJ']} ,
	{592: [' S ', '@SUBJ', '@FMV', '@ADVL']} ,
	{593: ['@ADVL', '@FMV', '@SUBJ', 'Z Com', '@SUBJ', 'Z Com', '@SUBJ']} ,
	{594: ['@SUBJ', '@ADVL', '@ADVL', '@FMV', '@PRD', '@OBJ', '@SUBJ', '@OBJ']} ,
	{595: ['@SUBJ', '@ADVL', '@ADVL', '@FMV', '@SUBJ']} ,
	{596: ['@OBJ', '@ADVL', '@FMV', '@IMV', '@PRD']} ,
	{597: ['@SUBJ', '@ADVL', '@FMV', '@ADVL', '@FMV', '@ADVL']} ,
	{598: ['@PRD', '@SUBJ', '@FMV', '@ADVL']} ,
	{599: ['@PRD', '@ADVL', '@ADVL', '@FMV', '@SUBJ']} ,
	{600: ['@SUBJ', 'Z Com', 'Z Com', '@NEG', '@FMV', '@IMV', '@OBJ']} ,
	{601: ['@SUBJ', 'Z Com', '@SUBJ', '@FMV', '@IMV', '@ADVL']} ,
	{602: ['@ADVL', ' S ', '@SUBJ', '@FMV', '@ADVL', '@OBJ']} ,
	{603: ['@SUBJ', '@ADVL', '@ADVL', '@PRD', '@ADVL', '@SUBJ', '@FMV', '@SUBJ']} ,
	{604: ['@ADVL', '@ADVL', '@FMV', '@OBJ', '@ADVL', '@SUBJ', '@ADVL']} ,
	{605: ['Z Com', '@ADVL', 'Z Com', '@ADVL', '@FMV', '@SUBJ', '@PRD']} ,
	{606: ['@OBJ', '@SUBJ', '@FMV', '@OBJ']} ,
	{607: ['@NEG', '@FMV', '@IMV', '@SUBJ']} ,
	{608: ['@SUBJ', '@OBJ', '@FMV', '@ADVL']} ,
	{609: [' P ', '@ADVL', '@IMV', '@ADVL', '@SUBJ', '@FMV']} ,
	{610: ['@SUBJ', 'ad', '@ADVL', '@FMV']} ,
	{611: ['@ADVL', '@ADVL', '@FMV', '@PRD', '@SUBJ', '@FMV', '@ADVL']} ,
	{612: ['@SUBJ', '@PRD', '@FMV']} ,
	{613: ['@ADVL', '@SUBJ', '@OBJ', '@IMV']} ,
	{614: ['@OBJ', '@ADVL', '@NEG', '@FMV', '@ADVL']} ,
	{615: ['@FMV', '@ADVL', '@OBJ', '@ADVL', '@ADVL', ' S ']} ,
	{616: ['Z Com', '@ADVL', '@SUBJ', '@ADVL', '@FMV', '@OBJ']} ,
	{617: ['@PRD', '@FMV', '@SUBJ', '@ADVL']} ,
	{618: ['@ADVL', '@OBJ', '@FMV', '@OBJ', '@FMV', '@SUBJ']} ,
	{619: ['@ADVL', '@ADVL', '@SUBJ', '@IMV']} ,
	{620: ['@ADVL', '@SUBJ', '@ADVL']} ,
	{621: ['@ADVL', '@FCV', '@ADVL', '@IMV']} ,
	{622: ['@ADVL', '@ADVL', '@SUBJ', '@FMV', '@ADVL', '@ADVL', ' S ']} ,
	{623: ['@OBJ', 'Z Com', '@PRD', '@ADVL', '@SUBJ']} ,
	{624: ['@OBJ', '@ADVL', '@SUBJ']} ,
	{625: ['@ADVL', ' S ', '@SUBJ', '@ADVL', '@FMV', '@PRD']} ,
	{626: ['@ADVL', '@ADVL', '@SUBJ', '@FMV', '@ADVL', '@FMV', '@PRD', '@ADVL', '@ADVL']} ,
	{627: ['@OBJ', '@ADVL', '@FMV', '@ADVL', '@ADVL', '@ADVL', 'Z Com', ' S ', '@IMV', '@OBJ', 'Z Com', '@OBJ']} ,
	{628: [' P ', '@ADVL', '@ADVL', '@FMV', '@SUBJ', '@ADVL']} ,
	{629: ['@ADVL', '@FMV', '@PRD', '@SUBJ', '@ADVL']} ,
	{630: ['@ADVL', '@ADVL', '@FMV', '@ADVL', '@SUBJ', '@OBJ']} ,
	{631: ['@ADVL', 'Z Com', '@NEG', '@FMV', '@SUBJ', '@OBJ']} ,
	{632: ['@PRD', '@NEG', '@FMV', '@SUBJ']} ,
	{633: ['@ADVL', '@ADVL', 'Z Com', '@SUBJ', '@FCV', '@IMV', '@IMV', '@OBJ']} ,
	{634: ['@OBJ', '@ADVL', '@ADVL', '@FMV', '@ADVL', '@IMV']} ,
	{635: ['ad', '@ADVL', '@ADVL', '@FMV', '@PRD', '@SUBJ', '@ADVL']} ,
	{636: ['@ADVL', '@SUBJ', '@ADVL', '@NEG', '@FMV', '@PRD']} ,
	{637: ['@ADVL', '@SUBJ', '@FMV', '@ADVL']} ,
	{638: ['@FMV', '@IMV', '@OBJ', '@FMV', '@OBJ']} ,
	{639: ['@ADVL', '@FMV', '@FMV', '@SUBJ']} ,
	{640: ['@SUBJ', '@FMV', '@ADVL', '@ADVL']} ,
	{641: ['@OBJ', '@FMV', '@ADVL']} ,
	{642: ['@ADVL', ' S ', '@SUBJ', '@FMV', '@ADVL']} ,
	{643: ['@ADVL', '@ADVL', '@ADVL', '@ADVL']} ,
	{644: ['@SUBJ', '@IMV', '@IMV']} ,
	{645: ['@ADVL', ' S ', '@ADVL', '@FMV', '@ADVL']} ,
	{646: ['ad', '@ADVL', '@ADVL', '@SUBJ', '@FMV', '@ADVL']}
])
